package neuralNetwork;

public class MLPLMT0App {
	int patN			= 4;
	int trainN			= 400;
	int numberLoadData	= 400;
	int numberTrainData	= 400;
	int numberTestData = 4;
	int batchSize		= 1;
	int numEpoch		= 10;
	double learnRate	= 0.1;
	double wMax			= 1.0;
	int numGamete 	= 4;
	int testSwitch	= 0;
	int numLayer = 4;
	int count00;
	int count01;
	int count10;
	int count11;
	int[] Gcount00 = new int[numGamete];
	int[] Gcount01 = new int[numGamete];
	int[] Gcount10 = new int[numGamete];
	int[] Gcount11 = new int[numGamete];

	double[][] trainDataUnit = {
			{ 0, 0 }, { 0, 1 }, { 1, 0 }, { 1, 1 }
	};

	double[][] teachDataUnit= {
			{ 0 }, { 1 }, { 1 }, { 0 }
	};

	double[][] testDataUnit = {
			{ 0, 0 }, { 0, 1 }, { 1, 0 }, { 1, 1 }
	};

	byte[] testLavelUnit = {0, 1, 1, 0};

	double[][] trainData = new double[numberTrainData][];

	double[][] teachData = new double[numberTrainData][];

	double[][] testData = new double[numberTrainData][];

	byte[] testLavel = new byte[numberTrainData];

	int loop = numberTrainData/patN;
	MLPLMT0 mlp = new MLPLMT0(numLayer, new int[] { 2, 2, 2, 1 }, wMax);

	public void run() {
		int testDataCount = 0;
		testDataCount = 0;
		count00 = 0; count01 = 0; count10 = 0; count11 = 0;
		for (int i=0; i < loop; i++){
			for (int j = 0; j < patN; j++) {
				trainData[i*patN + j] = trainDataUnit[j];
				teachData[i*patN+ j] = teachDataUnit[j];
				testData[i*patN+ j] = testDataUnit[j];
				testLavel[i*patN+ j] = testLavelUnit[j];
			}
		};

		mlp.train0(testSwitch, trainData, teachData, testData, testLavel, numberLoadData, numberTrainData, numberTestData,
				learnRate, numEpoch, batchSize, null);

		System.out.println("---test ----------------\nInput\t\tOutput");
		for (double[] d : testData) {
			mlp.forward(d);
			for (int k=0; k < numGamete; k++){
				for (int i = 0; i < d.length; i++) {
					System.out.printf("%.0f\t", d[i]);
				}
				for (int j = 0; j < mlp.unit[k][numLayer -1].length; j++) {
					System.out.printf("%.3f\t", mlp.unit[k][numLayer -1][j]);
					if ((testDataCount % 4) == 0){
						if (mlp.unit[k][numLayer -1][j] < 0.005)
							Gcount00[k]=1;
						else
							Gcount00[k]=0;
					}
					if((testDataCount % 4) == 1){
						if (mlp.unit[k][numLayer -1][j] > 0.995)
							Gcount01[k]=1;
						else
							Gcount01[k]=0;
					}
					if((testDataCount % 4) == 2){
						if (mlp.unit[k][numLayer -1][j] > 0.995)
							Gcount10[k]=1;
						else
							Gcount10[k]=0;
					}
					if((testDataCount % 4) == 3){
						if (mlp.unit[k][numLayer -1][j] < 0.005)
							Gcount11[k]=1;
						else
							Gcount11[k]=0;
					}

				}
				System.out.println(" : " + testDataCount);
			}
			testDataCount++;
		}
		for (int k = 0; k < numGamete; k++) {
			count00 += Gcount00[k]; count01 += Gcount01[k]; count10 += Gcount10[k]; count11 += Gcount11[k];
		}

		System.out.println("00: " + count00 + " out of " + numGamete + " Gametes  ratio: " + count00/(1.0*numGamete));
		System.out.println("01: " + count01 + " out of " + numGamete + " Gametes  ratio: " + count01/(1.0*numGamete));
		System.out.println("10: " + count10 + " out of " + numGamete + " Gametes  ratio: " + count10/(1.0*numGamete));
		System.out.println("11: " + count11 + " out of " + numGamete + " Gametes  ratio: " + count11/(1.0*numGamete));
	}

	public static void main(String[] args) {
		int numRepeat = 20;
		int numGamete = 4;
		int count00 = 0;
		int count01 = 0;
		int count10 = 0;
		int count11 = 0;
		int totalcount = 0;
		MLPLMT0App mp = new MLPLMT0App();
		for (int loopcount = 0; loopcount < numRepeat; loopcount++) {
			mp.run();
			count00 += mp.count00; count01 += mp.count01; count10 += mp.count10; count11 += mp.count11;
			for (int k=0; k<numGamete; k++) {
				if ((mp.Gcount00[k]==1) && (mp.Gcount01[k]==1) && (mp.Gcount10[k]==1) && (mp.Gcount11[k]==1))
					totalcount++;
			}
		}
		System.out.println("00: " + count00 + " out of " + 4.0*numRepeat + " ratio: " + count00/(4.0*numRepeat));
		System.out.println("01: " + count01 + " out of " + 4.0*numRepeat + " ratio: " + count01/(4.0*numRepeat));
		System.out.println("10: " + count10 + " out of " + 4.0*numRepeat + " ratio: " + count10/(4.0*numRepeat));
		System.out.println("11: " + count11 + " out of " + 4.0*numRepeat + " ratio: " + count11/(4.0*numRepeat));
		System.out.println("correct all: " + totalcount + " out of " + 4.0*numRepeat + " ratio: " + totalcount/(4.0*numRepeat));


	}
}
